PROGRAM genU

IMPLICIT NONE

INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(12, 32)
REAL (dp), PARAMETER :: pi=3.14159265358979
REAL (dp) :: N_tiles,area,d,d1,d2,d3,omega1,omega2,omega3,norm,u(1,4)
REAL (dp) :: binmat(8,4)
!REAL (dp) :: Q(4,4)
INTEGER :: k,ios

OPEN(Unit=6,file='directions.txt',IOSTAT=ios)
IF (ios.ne.0) THEN
  PRINT *,'error writting output file'
  STOP
ENDIF

!Q=RESHAPE( (/0.75, -0.25, -0.25, -0.25,  &
!            -0.25, 0.75, -0.25, -0.25,   &
!            -0.25, -0.25, 0.75, -0.25,   &
!            -0.25, -0.25, -0.25, 0.75/) ,(/4,4/))

40 FORMAT (4(F15.10))

binmat(1,:)=(/0.0, 0.0, 0.0, 1.0/)
binmat(2,:)=(/0.0, 0.0, 1.0, 0.0/)
binmat(3,:)=(/0.0, 1.0, 0.0, 0.0/)
binmat(4,:)=(/1.0, 0.0, 0.0, 0.0/)
binmat(5:8,:)=-binmat(1:4,:)

DO k=1,8
    norm=SQRT(SUM(binmat(k,:)**2))
    binmat(k,:)=binmat(k,:)/norm
    WRITE(Unit=6,FMT=40) binmat(k,:)
END DO

k=8
area=2.0*pi**2.0; !the area of the unit sphere's surface (R^4 specific)


N_tiles=113.0
d=(area/N_tiles)**(1.0/3.0);  !the "diameter" of each plate
d1=d
DO omega1=d1/2.0,pi,d1
    d2=d/sin(omega1)
    DO omega2=d2/2.0,pi,d2
        d3=d/(sin(omega1)*sin(omega2));
        DO omega3=d3/2.0,2.0*pi,d3
            u(1,:)=(/cos(omega1), sin(omega1)*cos(omega2), sin(omega1)*sin(omega2)*cos(omega3), sin(omega1)*sin(omega2)*sin(omega3)/)
            !u=MATMUL(u,Q)+0.25
            WRITE(Unit=6,FMT=40) u
            k=k+1 !just counts the number of tiles
        END DO
    END DO
END DO



N_tiles=410.0
d=(area/N_tiles)**(1.0/3.0);  !the "diameter" of each plate
d1=d
DO omega1=d1/2.0,pi,d1
    d2=d/sin(omega1)
    DO omega2=d2/2.0,pi,d2
        d3=d/(sin(omega1)*sin(omega2));
        DO omega3=d3/2.0,2.0*pi,d3
            u(1,:)=(/cos(omega1), sin(omega1)*cos(omega2), sin(omega1)*sin(omega2)*cos(omega3), sin(omega1)*sin(omega2)*sin(omega3)/)
            !u=MATMUL(u,Q)+0.25
            WRITE(Unit=6,FMT=40) u
            k=k+1 !just counts the number of tiles
        END DO
    END DO
END DO

N_tiles=625.0
d=(area/N_tiles)**(1.0/3.0);  !the "diameter" of each plate
d1=d
DO omega1=d1/2.0,pi,d1
    d2=d/sin(omega1)
    DO omega2=d2/2.0,pi,d2
        d3=d/(sin(omega1)*sin(omega2));
        DO omega3=d3/2.0,2.0*pi,d3
            u(1,:)=(/cos(omega1), sin(omega1)*cos(omega2), sin(omega1)*sin(omega2)*cos(omega3), sin(omega1)*sin(omega2)*sin(omega3)/)
            !u=MATMUL(u,Q)+0.25
            WRITE(Unit=6,FMT=40) u
            k=k+1 !just counts the number of tiles
        END DO
    END DO
END DO


CLOSE(Unit=6)
PRINT *,' '
PRINT *,'done generating directions'
PRINT *,' '
PRINT *, 'Total directions generated: ', k

END PROGRAM genU