idregions=importdata('C:\Users\arie\Documents\MATLAB\quickDGP1.txt');  %<--- change this if needed

idregions=sortrows(idregions,1);
I1=find(idregions(:,1)==1);
I2=find(idregions(:,1)==2);
I3=find(idregions(:,1)==3);

%% Theta
 lb=floor(min(min(idregions(I1,2:3))));
 ub=ceil(max(max(idregions(I1,2:3))));
 subplot(2,2,1)
 scatter(idregions(I1,2),idregions(I1,3),15,'oy','MarkerFaceColor','y')
 hold on
 scatter(idregions(I2,2),idregions(I2,3),15,'or','MarkerFaceColor','r')
 scatter(idregions(I3,2),idregions(I3,3),15,'ok','MarkerFaceColor','k')
 scatter(idregions(1,2),idregions(1,3),25,'+b','MarkerFaceColor','b')
 hold off
 title('Competive effects')
 xlabel('\theta_{1}','FontWeight','bold')
 ylabel('\theta_{2}','FontWeight','bold')
 legend('\Theta_{I}^{ABJ}','\Theta_{I}^{CT}','\Theta_{I}','Location','SouthWest')
 axis([lb ub lb ub])
!axis([-5 0 -5 0])
disp('Projections for thetas:')
disp('============')
disp('ABJ mixed:')
disp(min(idregions(I1,2:3)))
disp(max(idregions(I1,2:3)))
disp('CT mixed:')
disp(min(idregions(I2,2:3)))
disp(max(idregions(I2,2:3)))
disp('BMM mixed:')
disp(min(idregions(I3,2:3)))
disp(max(idregions(I3,2:3)))

%return
%% Beta1
 lb=floor(min(min(idregions(I1,4:5))));
 ub=ceil(max(max(idregions(I1,4:5))));
 subplot(2,2,2)
 scatter(idregions(I1,4),idregions(I1,5),15,'oy','MarkerFaceColor','y')
 hold on
 scatter(idregions(I2,4),idregions(I2,5),15,'or','MarkerFaceColor','r')
 scatter(idregions(I3,4),idregions(I3,5),15,'ok','MarkerFaceColor','k')
 scatter(idregions(1,4),idregions(1,5),25,'+b','MarkerFaceColor','b')
 
 hold off
 title('Coefficient for player 1''s covariates')
 xlabel('\beta1_{1}','FontWeight','bold')
 ylabel('\beta1_{2}','FontWeight','bold')
 legend('B1_{I}^{ABJ}','B1_{I}^{CT}','B1_{I}','Location','SouthWest')
 axis([lb ub lb ub])

disp('Projections beta1:')
disp('============')
disp('ABJ mixed:')
disp(min(idregions(I1,4:5)))
disp(max(idregions(I1,4:5)))
disp('CT mixed:')
disp(min(idregions(I2,4:5)))
disp(max(idregions(I2,4:5)))
disp('BMM mixed:')
disp(min(idregions(I3,4:5)))
disp(max(idregions(I3,4:5)))

%% Beta 2
 lb=floor(min(min(idregions(I1,7:8))));
 ub=ceil(max(max(idregions(I1,7:8))));
 subplot(2,2,3)
 scatter(idregions(I1,7),idregions(I1,8),15,'oy','MarkerFaceColor','y')
 hold on
 scatter(idregions(I2,7),idregions(I2,8),15,'or','MarkerFaceColor','r')
 scatter(idregions(I3,7),idregions(I3,8),15,'ok','MarkerFaceColor','k')
 scatter(idregions(1,7),idregions(1,8),25,'+b','MarkerFaceColor','b')
 hold off
 title('Coefficient for player 2''s covariates')
 xlabel('\beta2_{1}','FontWeight','bold')
 ylabel('\beta2_{2}','FontWeight','bold')
 legend('B2_{I}^{ABJ}','B2_{I}^{CT}','B2_{I}','Location','SouthWest')
 axis([lb ub lb ub])

disp('Projections beta2:')
disp('============')
disp('ABJ mixed:')
disp(min(idregions(I1,7:8)))
disp(max(idregions(I1,7:8)))
disp('CT mixed:')
disp(min(idregions(I2,7:8)))
disp(max(idregions(I2,7:8)))
disp('BMM mixed:')
disp(min(idregions(I3,7:8)))
disp(max(idregions(I3,7:8)))

%% Beta 0
 lb=floor(min(min(idregions(I1,[6 9]))));
 ub=ceil(max(max(idregions(I1,[6 9]))));
 subplot(2,2,4)
 scatter(idregions(I1,6),idregions(I1,9),15,'oy','MarkerFaceColor','y')
 hold on
 scatter(idregions(I2,6),idregions(I2,9),15,'or','MarkerFaceColor','r')
 scatter(idregions(I3,6),idregions(I3,9),15,'ok','MarkerFaceColor','k')
 scatter(idregions(1,6),idregions(1,9),25,'+b','MarkerFaceColor','b')
 hold off
 title('Intercepts')
 xlabel('\beta0_{1}','FontWeight','bold')
 ylabel('\beta0_{2}','FontWeight','bold')
 legend('B0_{I}^{ABJ}','B0_{I}^{CT}','B0_{I}','Location','SouthWest')
 axis([lb ub lb ub])

disp('Projections beta0:')
disp('============')
disp('ABJ mixed:')
disp(min(idregions(I1,[6 9])))
disp(max(idregions(I1,[6 9])))
disp('CT mixed:')
disp(min(idregions(I2,[6 9])))
disp(max(idregions(I2,[6 9])))
disp('BMM mixed:')
disp(min(idregions(I3,[6 9])))
disp(max(idregions(I3,[6 9])))

%% 3D
% figure(5)
% subplot(1,3,1)
% scatter3(idregions(I1,4),idregions(I1,5),idregions(I1,6),'y','k','filled'), view(-60,60)
% title('ABJ')
% axis([0.37 0.58 0.21 0.42 -0.24 0.19])
% subplot(1,3,2)
% scatter3(idregions(I2,4),idregions(I2,5),idregions(I2,6),'r','k','filled'), view(-60,60)
% title('CT')
% axis([0.37 0.58 0.21 0.42 -0.24 0.19])
% subplot(1,3,3)
% scatter3(idregions(I3,4),idregions(I3,5),idregions(I3,6),'k','k','filled'), view(-60,60)
% title('BMM')
% axis([0.37 0.58 0.21 0.42 -0.24 0.19])
