PROGRAM volumes

IMPLICIT NONE

INTEGER, PARAMETER       :: cov_num1=3 !the number of covariates that player 1 has plus intercept
INTEGER, PARAMETER       :: cov_num2=3 !the number of covariates that player 2 has plus intercept
INTEGER, PARAMETER       :: par_dim=2+cov_num1+cov_num2 !the total number of parameters equals two thetas plus the number of beta parameters
INTEGER, PARAMETER       :: cov_val1=4 !number of different values that the vector X1 can take
INTEGER, PARAMETER       :: cov_val2=5 !number of different values that the vector X2 can take
REAL (kind=8), Dimension(par_dim)           :: DLOW= (/-2.37D0,-2.34D0,0.37D0,0.21D0,-0.24D0,-0.40D0,-0.57D0,-0.87D0/) 
REAL (kind=8), Dimension(par_dim)           :: DHIGH=(/-0.46D0,-0.64D0,0.57D0,0.42D0, 0.19D0,-0.24D0,-0.41D0, 0.04D0/)
INTEGER, PARAMETER                          :: nobs=725258,n_ABJ=349422,n_CT=268322,n_BMM=107514
REAL (kind=8)                               :: x1,x2,x3,x4,th1,th2,beta11,beta12,beta10,beta21,beta22,beta20,dist
INTEGER                                     :: ios,i,j,counter,v_ABJ,v_CT,v_BMM,cord1,cord2,cord3,cord4
REAL (kind=8)                               :: par(nobs,8),point(4),grid_point(4),b(4),bandwidth(8)
INTEGER                                     :: id(nobs)
LOGICAL                                     :: BMM,CT
CHARACTER*10                                :: TIME
CHARACTER*8                                 :: DATE


!!!!!!!!!!!!!!!!!!!! input file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
40 FORMAT (1(I8),8(F20.15))
55 FORMAT (4(F8.5),3(I8),24(F8.5))

OPEN(Unit=6,file='quickDGP3.txt',IOSTAT=ios)
IF (ios.ne.0) THEN
  PRINT *,'error writting output file'
  STOP
ENDIF
DO i=1,nobs
    READ(unit=6,FMT=40) j,th1,th2,beta11,beta12,beta10,beta21,beta22,beta20
    par(i,:)=(/th1,th2,beta11,beta12,beta10,beta21,beta22,beta20/)
    id(i)=j
END DO
CLOSE(unit=6)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

bandwidth=(DHIGH-DLOW)/40.0
PRINT *,'----------------------------------------------------------'
PRINT *,'Start time:'
CALL DATE_AND_TIME(DATE,TIME)
PRINT *,TIME
PRINT *,'----------------------------------------------------------'



!! Player 1
cord1=1
cord2=3
cord3=4
cord4=5

counter=0
v_ABJ=0
v_CT=0
v_BMM=0
b=(/bandwidth(cord1),bandwidth(cord2),bandwidth(cord3),bandwidth(cord4)/)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO x1=DLOW(cord1)+bandwidth(cord1),DHIGH(cord1),2.0D0*bandwidth(cord1)
DO x2=DLOW(cord2)+bandwidth(cord2),DHIGH(cord2),2.0D0*bandwidth(cord2)
DO x3=DLOW(cord3)+bandwidth(cord3),DHIGH(cord3),2.0D0*bandwidth(cord3)
DO x4=DLOW(cord4)+bandwidth(cord4),DHIGH(cord4),2.0D0*bandwidth(cord4)

counter=counter+1
grid_point=(/x1,x2,x3,x4/)
CT=.FALSE.
BMM=.FALSE.
DO i=nobs,nobs-n_BMM+1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        BMM=.TRUE.
        v_ABJ=v_ABJ+1
        v_CT=v_CT+1
        v_BMM=v_BMM+1
        EXIT
    END IF
END DO
IF (BMM) GO TO 998
DO i=nobs-n_BMM,n_ABJ+1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        CT=.TRUE.
        v_CT=v_CT+1
        v_ABJ=v_ABJ+1
        EXIT
    END IF
END DO
IF (CT) GOTO 998
DO i=n_ABJ,1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        v_ABJ=v_ABJ+1
        EXIT
    END IF
END DO
998 CONTINUE
!PRINT *,counter,v_ABJ,v_CT,v_BMM

END DO
END DO
END DO
END DO
PRINT *,"PLAYER 1"
PRINT *,"========"
PRINT *,"# of points: ",counter,v_ABJ,v_CT,v_BMM
PRINT *,"v_ABJ=",v_ABJ
PRINT *,"v_CT=",v_CT
PRINT *,"v_BMM=",v_BMM
PRINT *,"v_CT/v_ABJ=",REAL(v_CT,kind=8)/REAL(v_ABJ,kind=8)
PRINT *,"v_BMM/v_ABJ=",REAL(v_BMM,kind=8)/REAL(v_ABJ,kind=8)
PRINT *,"v_BMM/v_CT=",REAL(v_BMM,kind=8)/REAL(v_CT,kind=8)


!! Player 2
cord1=2
cord2=6
cord3=7
cord4=8

counter=0
v_ABJ=0
v_CT=0
v_BMM=0
b=(/bandwidth(cord1),bandwidth(cord2),bandwidth(cord3),bandwidth(cord4)/)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DO x1=DLOW(cord1)+bandwidth(cord1),DHIGH(cord1),2.0D0*bandwidth(cord1)
DO x2=DLOW(cord2)+bandwidth(cord2),DHIGH(cord2),2.0D0*bandwidth(cord2)
DO x3=DLOW(cord3)+bandwidth(cord3),DHIGH(cord3),2.0D0*bandwidth(cord3)
DO x4=DLOW(cord4)+bandwidth(cord4),DHIGH(cord4),2.0D0*bandwidth(cord4)

counter=counter+1
grid_point=(/x1,x2,x3,x4/)
CT=.FALSE.
BMM=.FALSE.
DO i=nobs,nobs-n_BMM+1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        BMM=.TRUE.
        v_ABJ=v_ABJ+1
        v_CT=v_CT+1
        v_BMM=v_BMM+1
        EXIT
    END IF
END DO
IF (BMM) GO TO 999
DO i=nobs-n_BMM,n_ABJ+1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        CT=.TRUE.
        v_CT=v_CT+1
        v_ABJ=v_ABJ+1
        EXIT
    END IF
END DO
IF (CT) GOTO 999
DO i=n_ABJ,1,-1
    point=(/par(i,cord1),par(i,cord2),par(i,cord3),par(i,cord4)/)
    dist=MAXVAL( ABS( ((point-grid_point)/b) ) )
    IF (dist.LE.1.0D0) THEN
        v_ABJ=v_ABJ+1
        EXIT
    END IF
END DO
999 CONTINUE

!PRINT *,counter,v_ABJ,v_CT,v_BMM

END DO
END DO
END DO
END DO
PRINT *,"PLAYER 2"
PRINT *,"========"
PRINT *,"# of points: ",counter,v_ABJ,v_CT,v_BMM
PRINT *,"v_ABJ=",v_ABJ
PRINT *,"v_CT=",v_CT
PRINT *,"v_BMM=",v_BMM
PRINT *,"v_CT/v_ABJ=",REAL(v_CT,kind=8)/REAL(v_ABJ,kind=8)
PRINT *,"v_BMM/v_ABJ=",REAL(v_BMM,kind=8)/REAL(v_ABJ,kind=8)
PRINT *,"v_BMM/v_CT=",REAL(v_BMM,kind=8)/REAL(v_CT,kind=8)

PRINT *,'--------------------------------------'
PRINT *,'End time:'
CALL DATE_AND_TIME(DATE,TIME)
PRINT *,TIME
PRINT *,'--------------------------------------'
END PROGRAM volumes
